#ifndef _BOOST_UBLAS_IO_OVERLOAD
#define _BOOST_UBLAS_IO_OVERLOAD

#include <cstdio>

#include <boost/numeric/ublas/matrix_expression.hpp>

namespace boost 
{ 
    namespace numeric 
    {	 
	namespace ublas 
	{

	    template<typename E, typename T, typename ME>
	    std::basic_ostream<E, T> &operator << (std::basic_ostream<E, T> &os, const matrix_expression<ME> &m) 
	    {
		typedef typename ME::size_type size_type;

		size_type size1 = m ().size1 ();
		size_type size2 = m ().size2 ();
	  
		std::basic_ostringstream< E, T, std::allocator<E> > s;
	    
		s.setf(std::ios_base::scientific);
		s.setf(std::ios_base::showpos);
		s.setf(std::ios_base::uppercase);

		s.precision(4);

		s << '[' << size1 << ',' << size2 << "]";

		s << std::endl << std::endl;
	    
		for (size_type i = 0; i < size1; i++) 
		{
		    s << "    ";

		    for (size_type j = 0; j < size2; j++)
		    {
			s << m () (i, j) << " ";
		    }

		    s << std::endl;
		}
	    
		return os << s.str ().c_str ();
	    }

	}
    }
}

#endif
