#include <cstdio>
#include <cstdlib>
#include <ctime>

#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/io.hpp>

#include <boost/random/linear_congruential.hpp>
#include <boost/random/uniform_real.hpp>
#include <boost/random/variate_generator.hpp>

#include "io.hpp"

using namespace boost::numeric::ublas;

int main(int argc, char *argv[])
{
    boost::minstd_rand *_generator;
    boost::uniform_real<double> *_distribution;
    boost::variate_generator< boost::minstd_rand&, boost::uniform_real<double> > *_uniform;

    _generator = new boost::minstd_rand(static_cast<unsigned int>(std::time(NULL)));
    _distribution = new boost::uniform_real<double>(0, 1);
    _uniform = new boost::variate_generator< boost::minstd_rand&, boost::uniform_real<double> >(*_generator, *_distribution);

    matrix<double> A(4,5);

    for (unsigned int i = 0; i < A.size1(); i++)
    {
	for (unsigned int j = 0; j < A.size2(); j++)
	{
	    A(i,j) = (*_uniform)();
	}
    }
    std::cout << A << std::endl;

    matrix< std::complex<double> > B(4,5);

    for (unsigned int i = 0; i < B.size1(); i++)
    {
	for (unsigned int j = 0; j < B.size2(); j++)
	{
	    B(i,j).real() = (*_uniform)();
	    B(i,j).imag() = (*_uniform)();
	}
    }
    std::cout << B << std::endl;

    return EXIT_SUCCESS;
}

